﻿
function Lifebloomer_OnLoad_Dimensions()
	if LBDim then
		if LBDim.wild then
		else
			LBDim.wild = 2;
			if LBDim.rej then
			else
				LBDim.rej = 2;
				LBDim.reg = 2;
				LBDim.wild = 2;
			end
		end
	else
		LBDim = {};
		LBDim.h = 40;
		LBDim.w = 180;
		LBDim.s = 0;
		LBDim.rej = 2;
		LBDim.reg = 2;
		LBDim.wild = 2;
	end
	
	LB_Buffer.LBDim = {};
	LB_Buffer.LBDim = Lifebloomer_deepcopy(LBDim);
	
	Lifebloomer_AdjustH_Sample();
	Lifebloomer_AdjustW_Sample();
	--Lifebloomer_AdjustS_Sample();
	Lifebloomer_AdjustRejuv_Sample();
	Lifebloomer_AdjustRegro_Sample();
	Lifebloomer_AdjustWild_Sample();
	
	Lifebloomer_AdjustH();
	Lifebloomer_AdjustW();
	Lifebloomer_AdjustS();
	Lifebloomer_AdjustRejuv();
	Lifebloomer_AdjustRegro();
	Lifebloomer_AdjustWild();
end

function Lifebloomer_AdjustH_Sample()
	LifebloomerOptionsDimensionsSample:SetHeight(LB_Buffer.LBDim.h);
end

function Lifebloomer_AdjustH()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 0 do
		getglobal("LifebloomerMainFrameUnitFrame"..n):SetHeight(LBDim.h);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."TargetButton"):SetHeight((LBDim.h-10)/3);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."TargetButton"):SetWidth((LBDim.h-10)/3);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."ReduceButton"):SetHeight((LBDim.h-10)/3);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."ReduceButton"):SetWidth((LBDim.h-10)/3);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."IncreaseButton"):SetHeight((LBDim.h-10)/3);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."IncreaseButton"):SetWidth((LBDim.h-10)/3);
		n = n - 1;
	end
	LifebloomerMainFrame:SetHeight(16 + (LBDim.h * nv) + (LBDim.s * (nv - 1)));
end

function Lifebloomer_AdjustW_Sample()
	LifebloomerOptionsDimensionsSample:SetWidth(LB_Buffer.LBDim.w);
	LifebloomerOptionsDimensionsSampleLBBarGCD:ClearAllPoints();
	LifebloomerOptionsDimensionsSampleLBBarGCD:SetPoint("TOP", "LifebloomerOptionsDimensionsSampleLBBar", "TOPLEFT", LB_Buffer.LBDim.w*(1.5*(100-GetCombatRatingBonus(20))/100)/7, -1);
	LifebloomerOptionsDimensionsSampleLBBarGCD:SetPoint("BOTTOM", "LifebloomerOptionsDimensionsSampleLBBar", "BOTTOMLEFT", LB_Buffer.LBDim.w*(1.5*(100-GetCombatRatingBonus(20))/100)/7, 1);
end

function Lifebloomer_AdjustW()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 0 do
		getglobal("LifebloomerMainFrameUnitFrame"..n):SetWidth(LBDim.w);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."LBBarGCD"):ClearAllPoints();
		getglobal("LifebloomerMainFrameUnitFrame"..n.."LBBarGCD"):SetPoint("TOP", "LifebloomerMainFrameUnitFrame"..n.."LBBar", "TOPLEFT", LBDim.w*(1.5*(100-GetCombatRatingBonus(20))/100)/7, -1);
		getglobal("LifebloomerMainFrameUnitFrame"..n.."LBBarGCD"):SetPoint("BOTTOM", "LifebloomerMainFrameUnitFrame"..n.."LBBar", "BOTTOMLEFT", LBDim.w*(1.5*(100-GetCombatRatingBonus(20))/100)/7, 1);
		n = n - 1;
	end
	LifebloomerMainFrame:SetWidth(LBDim.w);
end

function Lifebloomer_AdjustS_Sample()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 1 do
		getglobal("LifebloomerMainFrameUnitFrame"..n):ClearAllPoints();
		getglobal("LifebloomerMainFrameUnitFrame"..n):SetPoint("TOP", "LifebloomerMainFrameUnitFrame"..(n-1), "BOTTOM", 0, -LB_Buffer.LBDim.s);
		n = n - 1;
	end
	LifebloomerMainFrame:SetHeight(16 + (LBDim.h * nv) + (LB_Buffer.LBDim.s * (nv - 1)));
end

function Lifebloomer_AdjustS()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 1 do
		getglobal("LifebloomerMainFrameUnitFrame"..n):ClearAllPoints();
		getglobal("LifebloomerMainFrameUnitFrame"..n):SetPoint("TOP", "LifebloomerMainFrameUnitFrame"..(n-1), "BOTTOM", 0, -LBDim.s);
		n = n - 1;
	end
	LifebloomerMainFrame:SetHeight(16 + (LBDim.h * nv) + (LBDim.s * (nv - 1)));
end

function Lifebloomer_AdjustRejuv_Sample()
	if LB_Buffer.LBDim.rej == 0 then
		LifebloomerOptionsDimensionsSampleRejuvBar:Hide();
		LifebloomerOptionsAppearanceSampleRejuvBar:Hide();
	else
		LifebloomerOptionsDimensionsSampleRejuvBar:Show();
		LifebloomerOptionsAppearanceSampleRejuvBar:Show();
		LifebloomerOptionsDimensionsSampleRejuvBar:SetHeight(LB_Buffer.LBDim.rej);
		LifebloomerOptionsAppearanceSampleRejuvBar:SetHeight(LB_Buffer.LBDim.rej);
	end
end

function Lifebloomer_AdjustRejuv()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 0 do
		if LBDim.rej == 0 then
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RejuvBar"):Hide();
		else
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RejuvBar"):Show();
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RejuvBar"):SetHeight(LBDim.rej);
		end
		n = n - 1;
	end
end

function Lifebloomer_AdjustRegro_Sample()
	if LB_Buffer.LBDim.reg == 0 then
		LifebloomerOptionsDimensionsSampleRegroBar:Hide();
		LifebloomerOptionsAppearanceSampleRegroBar:Hide();
	else
		LifebloomerOptionsDimensionsSampleRegroBar:Show();
		LifebloomerOptionsAppearanceSampleRegroBar:Show();
		LifebloomerOptionsDimensionsSampleRegroBar:SetHeight(LB_Buffer.LBDim.reg);
		LifebloomerOptionsAppearanceSampleRegroBar:SetHeight(LB_Buffer.LBDim.reg);
	end
end

function Lifebloomer_AdjustRegro()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 0 do
		if LBDim.reg == 0 then
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RegroBar"):Hide();
		else
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RegroBar"):Show();
			getglobal("LifebloomerMainFrameUnitFrame"..n.."RegroBar"):SetHeight(LBDim.reg);
		end
		n = n - 1;
	end
end

function Lifebloomer_AdjustWild_Sample()
	if LB_Buffer.LBDim.wild == 0 then
		LifebloomerOptionsDimensionsSampleWildBar:Hide();
		LifebloomerOptionsAppearanceSampleWildBar:Hide();
	else
		LifebloomerOptionsDimensionsSampleWildBar:Show();
		LifebloomerOptionsAppearanceSampleWildBar:Show();
		LifebloomerOptionsDimensionsSampleWildBar:SetHeight(LB_Buffer.LBDim.wild);
		LifebloomerOptionsAppearanceSampleWildBar:SetHeight(LB_Buffer.LBDim.wild);
	end
end

function Lifebloomer_AdjustWild()
	local nv = getn(LBV);
	local n = nv + LBVFF;
	while n > 0 do
		if LBDim.reg == 0 then
			getglobal("LifebloomerMainFrameUnitFrame"..n.."WildBar"):Hide();
		else
			getglobal("LifebloomerMainFrameUnitFrame"..n.."WildBar"):Show();
			getglobal("LifebloomerMainFrameUnitFrame"..n.."WildBar"):SetHeight(LBDim.wild);
		end
		n = n - 1;
	end
end

function Lifebloomer_OptionsDimensions_Accept()
	LBDim = Lifebloomer_deepcopy(LB_Buffer.LBDim);
	Lifebloomer_AdjustH();
	Lifebloomer_AdjustW();
	Lifebloomer_AdjustS();
	Lifebloomer_AdjustRejuv();
	Lifebloomer_AdjustRegro();
	Lifebloomer_AdjustWild();
end

function Lifebloomer_OptionsDimensions_Cancel()
	LB_Buffer.LBDim = Lifebloomer_deepcopy(LBDim);
	Lifebloomer_AdjustH();
	Lifebloomer_AdjustW();
	Lifebloomer_AdjustS();
	Lifebloomer_AdjustRejuv();
	Lifebloomer_AdjustRegro();
	Lifebloomer_AdjustWild();
end

function Lifebloomer_OptionsDimensions_Default()
	LB_Buffer.LBDim.h = 40;
	LB_Buffer.LBDim.w = 180;
	LB_Buffer.LBDim.s = 0
	LB_Buffer.LBDim.rej = 2;
	LB_Buffer.LBDim.reg = 2;
	LB_Buffer.LBDim.wild = 2;
	LifebloomerOptionsDimensionsVerticalSlider:SetValue(LB_Buffer.LBDim.h);
	LifebloomerOptionsDimensionsHorizontalSlider:SetValue(LB_Buffer.LBDim.w);
	LifebloomerOptionsDimensionsSpacingSlider:SetValue(LB_Buffer.LBDim.s);
	LifebloomerOptionsDimensionsRejuvSlider:SetValue(LB_Buffer.LBDim.rej);
	LifebloomerOptionsDimensionsRegrowthSlider:SetValue(LB_Buffer.LBDim.reg);
	LifebloomerOptionsDimensionsWildSlider:SetValue(LB_Buffer.LBDim.wild);
	Lifebloomer_AdjustH_Sample();
	Lifebloomer_AdjustW_Sample();
	Lifebloomer_AdjustS_Sample();
	Lifebloomer_AdjustRejuv_Sample();
	Lifebloomer_AdjustRegro_Sample();
	Lifebloomer_AdjustWild_Sample();
end
